/*
 * Vifir - An electronic flight bag wannabe utility for aircraft pilots
 * Copyright (C) 2009 David Ludlow
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * dave@adsllc.com, PO Box 13070, Toledo, OH 43623
 */

/* This code was adapted from http://www.createwindow.com/programming/crc32/index.htm
 * It is believed to be free (Public Domain)
 */
#ifndef CRC32_H_
#define CRC32_H_

#include <stdint.h>

class CRC32 {
public:
	CRC32();
    uint32_t Compute(void *data, int len, uint32_t CRC=0xFFFFFFFF);	/* Creates a CRC from a text string */
    uint32_t Finalize(uint32_t CRC);	/* Gives the final result */

private:
	uint32_t LookupTable[256];					/* Lookup table array */ 
    void InitCRCTable();						/* Builds lookup table array */
    uint32_t Reflect(uint32_t ref, char ch);	/* Reflects CRC bits in the lookup table */
};

#endif /*CRC32_H_*/
